// CavePointer.hh
#ifndef __CAVEPOINTER_HH_
#define __CAVEPOINTER_HH_
/*  (Attempt to simplify the naming... it didn't work!)
enum CavePointerType {head=CAVE_HEAD,
		      wand=CAVE_WAND,
		      wand_front=CAVE_WAND_FRONT,
		      wand_back=CAVE_WAND_BACK,
		      left_eye=CAVE_LEFT_EYE,
		      right_eye=CAVE_RIGHT_EYE};
*/

/*=====================================================
Class: CavePointer
Purpoase: OK, I felt an uncontrollable urge to encapsulate
          the wand and head orientation in a class so I
	  didn't have to type those long CAVEDoThis() and
	  CAVEDoThat() commands!

	  It makes it easier to get the position,
	  orientation, and unit-vector direction
	  of tracked devices.
=======================================================*/
#include <pfcave.h>
#include <Performer/pr/pfLinMath.h>
class CavePointer {
private:
  CAVEID device; // a CavePointerType really
  //CavePointerType ptrType; // redundant, but fakes out c++
public:
  //CavePointer(CavePointerType ptr); // this produced annoying warnings
  CavePointer(CAVEID ptr);
  // subclass CaveSensor
  void orientation(float v[3]);
  void position(float v[3]);
  void worldPosition(float v[3]);
  inline void cavePosition(float v[3]){ position(v); }
  void unitVectorDirection(float v[3]);
  inline void vector(float v[3]){unitVectorDirection(v);}
  void orientation(pfVec3 &v);
  void position(pfVec3 &v);
  void worldPosition(pfVec3 &v);
  inline void cavePosition(pfVec3 &v){ position(v); }
  void unitVectorDirection(pfVec3 &v);
  inline void vector(pfVec3 &v){unitVectorDirection(v);}
};

/*  (will finish this sometime or another...encapsulates joystick
class CaveIntValuator {
private:
  CAVE_DEVICE_ID device;
public:
  CaveIntValuator(CAVE_DEVICE_ID dev);
  long getValue();
};
*/

extern CavePointer CaveWand;  // the wand
extern CavePointer CaveHead;  // your head
#endif // __CAVEPOINTER_HH_
