// NavPath
#ifndef __NAVPATH_HH_
#define __NAVPATH_HH_ 
#include <Performer/pf/pfDCS.h>
#include "NavBase.hh"
class NavPath : public NavBase {
	struct	shared {
		int	appid;
		int	cullid;
		int	drawid;
		int	interp;
		int	numDCSMAX;
		pfDCS	**DCSarray;
	};
	shared *Shared;
	char    buffer[100];
	char *coordfile;
	// pfDCS *nav_dcs inherited from parent
	
	// Private Methods
	void testIKey(void);
	void interpDCS( float t );
	void InterpolateCoord( pfDCS **DCSarray, float t, pfCoord *c);
	void xprintDCS( pfDCS *dcs, char *label);
	void WhichProcess( pid_t pid, char *routine, char *file, int line);
	void BuildDCS();
	void InitSharedMemory();
	void initShared(void);
	void printVec3( const pfVec3 &v, char *label);
	void dropOutDCS(void);
	void testDKey(void);
	void navigate(pfDCS *dcs); // update will call this using navdcs as an arg
public:
	NavPath(pfDCS *dcs,char *navfile="COORDS");
	~NavPath();
	//void loadPath(char *filename); // load a path... (in callback?)
	virtual void update();
};

#endif
