#ifndef __OBJECTMASKS_HH_
#define __OBJECTMASKS_HH_

/****************************************************
Definition of Masks for Intersection testing of objects
Always test for intersection using the movingDCS as the
root for the intersection test's position.  You will need
to go to the scene root to get the proper orientation with
respect to the wand orientation...

This information is global, hence the global file
*****************************************************/

//#define USERINTERFACEMASK 0x0001
#define BATHYMETRYMASK 0x0002
#define WATERSURFACEMASK 0x0004
#define TOOLMASK   0x0008
// Tools
#define ISOMASK     0x0010 | TOOLMASK
#define SLICEMASK  0x0020 | TOOLMASK
#define CUBEMASK  0x0040 | TOOLMASK
#define GRIDMASK   0x0080 | TOOLMASK
#define BOUYMASK  0x0100 | TOOLMASK
#define GLYPHMASK 0x0200 | TOOLMASK
#define MENUPANELMASK 0x0400
#define USERINTERFACEMASK 0x0001 | MENUPANELMASK
// FOR WALKING...
#define FLOORMASK BATHYMETRYMASK
#include <Performer/pf.h>
#include <Performer/pf/pfNode.h>
inline void SetObjectType(pfNode *obj,uint mask){
  obj->setTravMask(PFTRAV_ISECT,mask,PFTRAV_SELF|PFTRAV_DESCEND,PF_SET);
}
inline void SetCachedObjectType(pfNode *obj,uint mask){
  obj->setTravMask(PFTRAV_ISECT,mask,
		PFTRAV_SELF|PFTRAV_DESCEND|PFTRAV_IS_CACHE,PF_SET);
}
/*
inline void SetObjectTypeFromChildren(pfNode *obj){
  // this doesn't look at all correct!!
  obj->setTravMask(PFSET_OR,PFTRAV_SET_FROM_CHILD,0x0);
  // OK, well, this doesn't look too damned correct either
  //pfNodeTravMask(obj,PFTRAV_ISECT,0x00,PFTRAV_SET_FROM_CHILD,PFSET_OR);
}
*/

#endif
